package com.example.lifecyclelogger;

import android.database.Cursor;
import androidx.room.EntityInsertionAdapter;
import androidx.room.RoomDatabase;
import androidx.room.RoomSQLiteQuery;
import androidx.room.SharedSQLiteStatement;
import androidx.room.util.CursorUtil;
import androidx.room.util.DBUtil;
import androidx.sqlite.db.SupportSQLiteStatement;
import java.lang.Class;
import java.lang.Override;
import java.lang.String;
import java.lang.SuppressWarnings;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

@SuppressWarnings({"unchecked", "deprecation"})
public final class LifecycleEventDao_Impl implements LifecycleEventDao {
  private final RoomDatabase __db;

  private final EntityInsertionAdapter<LifecycleEvent> __insertionAdapterOfLifecycleEvent;

  private final SharedSQLiteStatement __preparedStmtOfDeleteAllEvents;

  public LifecycleEventDao_Impl(RoomDatabase __db) {
    this.__db = __db;
    this.__insertionAdapterOfLifecycleEvent = new EntityInsertionAdapter<LifecycleEvent>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR ABORT INTO `lifecycle_events` (`id`,`eventName`,`timestamp`) VALUES (nullif(?, 0),?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, LifecycleEvent value) {
        stmt.bindLong(1, value.getId());
        if (value.getEventName() == null) {
          stmt.bindNull(2);
        } else {
          stmt.bindString(2, value.getEventName());
        }
        stmt.bindLong(3, value.getTimestamp());
      }
    };
    this.__preparedStmtOfDeleteAllEvents = new SharedSQLiteStatement(__db) {
      @Override
      public String createQuery() {
        final String _query = "DELETE FROM lifecycle_events";
        return _query;
      }
    };
  }

  @Override
  public void insertEvent(final LifecycleEvent event) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      __insertionAdapterOfLifecycleEvent.insert(event);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public void deleteAllEvents() {
    __db.assertNotSuspendingTransaction();
    final SupportSQLiteStatement _stmt = __preparedStmtOfDeleteAllEvents.acquire();
    __db.beginTransaction();
    try {
      _stmt.executeUpdateDelete();
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
      __preparedStmtOfDeleteAllEvents.release(_stmt);
    }
  }

  @Override
  public List<LifecycleEvent> getAllEvents() {
    final String _sql = "SELECT * FROM lifecycle_events ORDER BY timestamp DESC";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    __db.assertNotSuspendingTransaction();
    final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
    try {
      final int _cursorIndexOfId = CursorUtil.getColumnIndexOrThrow(_cursor, "id");
      final int _cursorIndexOfEventName = CursorUtil.getColumnIndexOrThrow(_cursor, "eventName");
      final int _cursorIndexOfTimestamp = CursorUtil.getColumnIndexOrThrow(_cursor, "timestamp");
      final List<LifecycleEvent> _result = new ArrayList<LifecycleEvent>(_cursor.getCount());
      while(_cursor.moveToNext()) {
        final LifecycleEvent _item;
        final String _tmpEventName;
        if (_cursor.isNull(_cursorIndexOfEventName)) {
          _tmpEventName = null;
        } else {
          _tmpEventName = _cursor.getString(_cursorIndexOfEventName);
        }
        final long _tmpTimestamp;
        _tmpTimestamp = _cursor.getLong(_cursorIndexOfTimestamp);
        _item = new LifecycleEvent(_tmpEventName,_tmpTimestamp);
        final int _tmpId;
        _tmpId = _cursor.getInt(_cursorIndexOfId);
        _item.setId(_tmpId);
        _result.add(_item);
      }
      return _result;
    } finally {
      _cursor.close();
      _statement.release();
    }
  }

  public static List<Class<?>> getRequiredConverters() {
    return Collections.emptyList();
  }
}
